/*  This file should be edited with 4-column tabs! */
/*  Author: Mark Moraes <moraes@csri.toronto.edu> */
/* $Header: /nfs/ephemeral/smoke/src/zmailer/lm/RCS/malloc.h,v 1.2 89/12/17 22:34:20 rayan Exp $ */
#ifndef __XMALLOC_H__
#define __XMALLOC_H__

#ifdef __STDC__
#define ANSI_TYPES
#else
#define const
#endif

#ifdef ANSI_TYPES
#define univptr_t	void *
#else	/* ! ANSI_TYPES */
#define univptr_t	char *
#define	size_t		unsigned int
#endif	/* ANSI_TYPES */

#if defined(ANSI_TYPES) && !defined(__STDC__)
#define size_t		unsigned long
#endif

#if defined(__STDC__)
#define __proto(x)	x
#else
#define __proto(x)	()
#endif

/*
 *  defined so users of new features of this malloc can #ifdef
 *  invocations of those features.
 */
#define CSRIMALLOC

/*
 * The ZMailer additions come here.
 */
#ifdef MALLOC_TRACE

extern univptr_t __tmalloc __proto((size_t, const char *, int));
extern univptr_t __smalloc __proto((size_t, int, const char *, int));
extern char *__strnsave __proto((const char *, int, const char *, int));
extern struct conscell *__s_copy_tree __proto((struct conscell *, const char *, int));
extern void __s_free_tree __proto((struct conscell *, const char *, int));
#include "splay.h"
extern struct spblk *__sp_install __proto((spkey_t, unsigned char *, int, struct sptree *, const char *, int));
extern unsigned int __symbol __proto((char *, const char *, int));

#define tmalloc(x)		__tmalloc((x), __FILE__, __LINE__)
#define smalloc(m,x)		__smalloc((m), (x), __FILE__, __LINE__)
#define strnsave(p,n)		__strnsave((p), (n), __FILE__, __LINE__)
#define s_copy_tree(l)		__s_copy_tree((l), __FILE__, __LINE__)
#define s_free_tree(l)		__s_free_tree((l), __FILE__, __LINE__)
#define sp_install(k,d,m,q)	__sp_install((k),(d),(m),(q),__FILE__,__LINE__)
#define symbol(s)		__symbol((s),__FILE__,__LINE__)
  
#else /* MALLOC_TRACE */

extern univptr_t tmalloc __proto((size_t));
extern univptr_t smalloc __proto((int, size_t));
extern char *strnsave __proto((const char *, size_t));
extern struct conscell *s_copy_tree __proto((struct conscell *));
extern void s_free_tree __proto((struct conscell *));
extern unsigned int symbol __proto((unsigned char *));

#endif /* MALLOC_TRACE */

extern void mal_load __proto((void));

/* *** End of ZMailer additions */


#ifdef MALLOC_TRACE
/* Tracing malloc definitions - helps find leaks */

extern univptr_t __malloc __proto((size_t, const char *, int));
extern univptr_t __calloc __proto((size_t, size_t, const char *, int));
extern univptr_t __realloc __proto((univptr_t, size_t, const char *, int));
extern univptr_t __valloc __proto((size_t, const char *, int));
extern univptr_t __memalign __proto((size_t, size_t, const char *, int));
extern univptr_t __emalloc __proto((size_t, const char *, int));
extern univptr_t __erealloc __proto((univptr_t, size_t, const char *, int));
extern char *__strdup __proto((const char *, const char *, int));
extern char *__strsave __proto((const char *, const char *, int));
extern void __free __proto((univptr_t, const char *, int));
extern void __cfree __proto((univptr_t, const char *, int));

#define malloc(x)		__malloc((x), __FILE__, __LINE__)
#define calloc(x, n)	__calloc((x), (n), __FILE__, __LINE__)
#define realloc(p, x)	__realloc((p), (x), __FILE__, __LINE__)
#define memalign(x, n)	__memalign((x), (n), __FILE__, __LINE__)
#define valloc(x)		__valloc((x), __FILE__, __LINE__)
#define emalloc(x)		__emalloc((x), __FILE__, __LINE__)
#define erealloc(p, x)	__erealloc((p), (x), __FILE__, __LINE__)
#define strdup(p)		__strdup((p), __FILE__, __LINE__)
#define strsave(p)		__strsave((p), __FILE__, __LINE__)
/* cfree and free are identical */
#define cfree(p)		__free((p), __FILE__, __LINE__)
#define free(p)			__free((p), __FILE__, __LINE__)

#else /* MALLOC_TRACE */

extern univptr_t malloc __proto((size_t));
extern univptr_t calloc __proto((size_t, size_t));
extern univptr_t realloc __proto((univptr_t, size_t));
extern univptr_t valloc __proto((size_t));
extern univptr_t memalign __proto((size_t, size_t));
extern univptr_t emalloc __proto((size_t));
extern univptr_t erealloc __proto((univptr_t, size_t));
extern char *strdup __proto((const char *));
extern char *strsave __proto((const char *));
extern void free __proto((univptr_t));
extern void cfree __proto((univptr_t));

#endif /* MALLOC_TRACE */

extern void mal_contents __proto((FILE *));
extern void mal_debug __proto((int));
extern void mal_dumpleaktrace __proto((FILE *));
extern void mal_heapdump __proto((FILE *));
extern void mal_leaktrace __proto((int));
extern void mal_sbrkset __proto((int));
extern void mal_slopset __proto((int));
extern void mal_statsdump __proto(());
extern void mal_setstatsfile __proto((FILE *));
extern void mal_trace __proto((int));
extern int mal_verify __proto((int));



/*
 *  You may or may not want this - In gcc version 1.30, on Sun3s running
 *  SunOS3.5, this works fine.
 */
#ifdef __GNUC__
#define alloca(n) __builtin_alloca(n)
#endif /* __GNUC__ */
#ifdef sparc
#define alloca(n) __builtin_alloca(n)
#endif /* sparc */

/* Just in case you want an ANSI malloc without an ANSI compiler */
#if defined(ANSI_TYPES) && !defined(__STDC__)
#undef size_t
#endif

#undef __proto

#endif /* __XMALLOC_H__ */ /* Do not add anything after this line */
